import type { GomokuDirectionType } from './constant';
export declare class GomokuContext {
    readonly MAX_ROW: number;
    readonly MAX_COL: number;
    readonly MAX_INLINE: number;
    readonly NEXT_MOVER_BUFFER_FAC: number;
    readonly TOTAL_POS: number;
    readonly TOTAL_PLAYERS: number;
    constructor(MAX_ROW: number, MAX_COL: number, MAX_INLINE: number, NEXT_MOVER_BUFFER_FAC?: number);
    idx(r: number, c: number): number;
    idxIfValid(r: number, c: number): number;
    reIdx(id: number): [r: number, c: number];
    isValidPos(r: number, c: number): boolean;
    isInvalidPos(r: number, c: number): boolean;
    move(r: number, c: number, dirType: GomokuDirectionType, step: number): [r2: number, c2: number];
    validNeighbors(r: number, c: number): Iterable<[r2: number, c2: number, dirType: GomokuDirectionType]>;
    /**
     * Traverse in the recursive order.
     * @param handle
     */
    traverseAllDirections(handle: (r: number, c: number, dirType: GomokuDirectionType) => void): void;
    traverseLeftDirections(handle: (r: number, c: number, dirType: GomokuDirectionType) => void): void;
    traverseRightDirections(handle: (r: number, c: number, dirType: GomokuDirectionType) => void): void;
}
