import type { GomokuDirectionType } from './constant';
import type { GomokuContext } from './GomokuContext';
import type { IGomokuBoard, IScoreMap, IShapeCount } from './types';
export declare class GomokuCountMap {
    protected readonly context: Readonly<GomokuContext>;
    protected readonly board: Readonly<IGomokuBoard>;
    protected readonly dirCountMap: Uint32Array[];
    protected readonly conShapeCountMap: IShapeCount[][];
    protected readonly gapShapeCountMap: IShapeCount[][];
    protected readonly scoreMap: IScoreMap;
    constructor(context: Readonly<GomokuContext>, board: Readonly<IGomokuBoard>, scoreMap: IScoreMap);
    init(): void;
    beforeForward(r: number, c: number): void;
    afterForward(r: number, c: number): void;
    beforeRollback(r: number, c: number): void;
    afterRollback(r: number, c: number, player: number): void;
    score(currentPlayer: number, scoreForPlayer: number): number;
    hasReachedTheLimit(player: number): boolean;
    toJSON(): {
        dirCountMap: Uint32Array[];
        conShapeCountMap: IShapeCount[][];
        gapShapeCountMap: IShapeCount[][];
    };
    protected updateRelatedConShapeCountMap(centerR: number, centerC: number, dirType: GomokuDirectionType, v: number): void;
    protected updateConShapeCountMap(startR: number, startC: number, dirType: GomokuDirectionType, v: number): void;
    protected updateRelatedGapShapeCountMap(centerR: number, centerC: number, dirType: number, v: number): void;
    protected detectGapShape(r: number, c: number, dirType: number, v: number): void;
    protected updateGapShapeCountMap(player: number, startR: number, startC: number, lftCnt: number, rhtCnt: number, dirType: GomokuDirectionType, v: number): void;
    protected countFreeSide(player: number, startR: number, startC: number, cnt: number, dirType: number): number;
}
