import { GomokuContext } from './GomokuContext';
import { GomokuState } from './GomokuState';
import { GomokuStateCompressor } from './GomokuStateCompressor';
import type { IGomokuPiece, IScoreMap } from './types';
export declare class GomokuSolution {
    protected readonly MAX_DEPTH: number;
    protected readonly context: GomokuContext;
    protected readonly state: GomokuState;
    protected readonly stateCompressor: GomokuStateCompressor;
    protected readonly stateCache: Map<bigint, number>;
    protected scoreForPlayer: number;
    protected bestR: number;
    protected bestC: number;
    constructor(MAX_ROW: number, MAX_COL: number, MAX_INLINE?: number, MAX_DEPTH?: number, NEXT_MOVER_BUFFER_FAC?: number, scoreMap?: IScoreMap);
    init(pieces: ReadonlyArray<IGomokuPiece>): void;
    move(r: number, c: number, p: number): void;
    minmaxMatch(currentPlayer: number): [r: number, c: number];
    protected alphaBeta(player: number, alpha: number, beta: number, cur: number, prevState: bigint, stateScore: number): number;
}
