import type { GomokuContext } from './GomokuContext';
import { GomokuCountMap } from './GomokuCountMap';
import type { IGomokuBoard, IGomokuCandidateState, IGomokuPiece, IScoreMap } from './types';
export declare class GomokuState {
    protected readonly context: GomokuContext;
    protected readonly countMap: GomokuCountMap;
    protected readonly candidateSet: Set<number>;
    protected readonly board: IGomokuBoard;
    protected placedCount: number;
    constructor(context: GomokuContext, scoreMap: IScoreMap);
    init(pieces?: ReadonlyArray<IGomokuPiece>): void;
    forward(r: number, c: number, player: number): void;
    rollback(r: number, c: number): void;
    expand(currentPlayer: number, scoreForPlayer: number): IGomokuCandidateState[];
    score(currentPlayer: number, scoreForPlayer: number): number;
    isFinal(): boolean;
    randomMove(): [r: number, c: number];
    protected hasPlacedNeighbors(r: number, c: number): boolean;
    protected beforeForward(r: number, c: number): void;
    protected afterForward(r: number, c: number): void;
    protected beforeRollback(r: number, c: number): void;
    protected afterRollback(r: number, c: number, player: number): void;
}
